const keyCode = 'code';
const keyMessage = 'message';
const keyRequestId = 'request_id';
const keyData = 'data';
const keySuccessCode = '0000';

class BaseEntity<T> {
  bool isSuccess;
  String code;
  String message;
  String requestId;
  T data;
  List<T> listData;

  BaseEntity({this.code, this.message, this.requestId, this.data, this.listData, this.isSuccess});

  factory BaseEntity.fromJson(responseMap, T Function(Map<String, dynamic>) parseDataMap) {
    
    var resultSuccess = false;
    var code = responseMap[keyCode];
    if (code == keySuccessCode) {
      resultSuccess = true;
    }

    var dataEntity = responseMap[keyData];
    var data;
    if (dataEntity is Map<String, dynamic>) {
      data = parseDataMap(dataEntity);
    }

    var list;
    if (dataEntity is List) {
      list = List();
      (dataEntity).forEach((v) {
        list.add(parseDataMap(v));
      });
    }
    
    return BaseEntity(
      isSuccess: resultSuccess,
      code: code,
      message: responseMap[keyMessage],
      requestId: responseMap[keyRequestId],
      data: data,
      listData: list,
    );
  }
}