import 'package:fe_network/fe_network.dart';

import 'package:flutter_test/flutter_test.dart';

void main() {

  DataEntity map(Map<String, dynamic> dataMap) {
    return DataEntity.fromJson(dataMap);
  }
//
//  final entity = BaseEntity.fromJson({'code': '0000', 'message': '', 'data': {'protocol': {'name': 'protocol111', 'id': '11111'}, 'tips': {'name': 'tips111', 'id': '2222'}}}, map);
//
//  print('object::requestId:${entity.requestId}::code:${entity.code}::message:${entity.message}::tips.name:${entity.data.tips.name}::tips.id:${entity.data.tips.id}::protocol.name:${entity.data.protocol.name}::protocol.id:${entity.data.protocol.id}');

  test('my first unit test', () {

    final network = FeNetworkManager.shareInstance(baseUrl: 'http://www.mocky.io');

    network.request(FeNetworkMethod.get, '/v2/5d7fc75c3300000476f0b557');

    final entity = network.requestEntity<DataEntity>(FeNetworkMethod.get, '/v2/5d7fc75c3300000476f0b557', map);
  });

}

class ApiUrl {
  static const baseUrl1 = 'https://xxx.com';
  static const baseUrl2 = 'https://xx.xxx.com';
  static const listPath1 = '/app/v1/src/list1';
  static const listPath2 = '/app/v1/src/list2';
}

class DataEntity {
  ProtocolEntity protocol;
  TipsEntity tips;

  DataEntity(this.protocol, this.tips);

  factory DataEntity.fromJson(Map map) {
    return DataEntity(ProtocolEntity.fromJson(map['protocol']), TipsEntity.fromJson(map['tips']));
  }
}

class ProtocolEntity {
  final String name;
  final String id;

  factory ProtocolEntity.fromJson(Map map) {
    return ProtocolEntity(map['name'], map['id']);
  }

  ProtocolEntity(this.name, this.id);
}

class TipsEntity {
  final String name;
  final String id;

  factory TipsEntity.fromJson(Map map) {
    return TipsEntity(map['name'], map['id']);
  }

  TipsEntity(this.name, this.id);
}
